//   Copyright 2012 Georg-August-Universität Göttingen, Germany
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.

package de.ugoe.cs.autoquest.tasktrees.treeifc;

import java.util.List;

// TODO: Auto-generated Javadoc
/**
 * <p>
 * A structuring temporal relationship defines a temporal information for
 * several nodes in the task model. I.e., it has several children and defines an
 * execution order for them.
 * </p>
 * 
 * @author Patrick Harms
 */
public interface IStructuringTemporalRelationship extends ITemporalRelationship {

	/**
	 * <p>
	 * returns an exact copy of this temporal relationship. The clone has the
	 * same id. Its children are clones of the children of the cloned task. A
	 * call on the method {@link #equals(ITask)} with the result of this method
	 * must return true.
	 * </p>
	 * 
	 * @return as described
	 */
	@Override
	public IStructuringTemporalRelationship clone();

	/**
	 * <p>
	 * returns the children of this temporal relationship.
	 * </p>
	 * 
	 * @return as described
	 */
	public List<ITask> getChildren();

}
